<template>
  <!-- The collabscore sidebar
    very similar to <sidebar> but many elements are removed
    and the search box is filtered and redirects to collabscore route
  -->
  <v-navigation-drawer
    app
    :color="$store.state.secondaryColor"
    :width="400"
    :mini-variant.sync="isMinified"
    permanent
  >
    <template #prepend>
      <sidebar-title
        :is-minified.sync="isMinified"
      />
    </template>
    <template #default>
      <!-- Page specific buttons -->
      <!-- Passes isMinified as a prop to change display -->
      <portal-target
        :slot-props="{ isMinified }"
        name="sidebar-buttons"
      />
    </template>
    <template #append>
      <v-list nav dense>
        <login-button :client="loginClient" />
        <locale-switcher />
      </v-list>
    </template>
  </v-navigation-drawer>
</template>
<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator';
import type { Piece } from '@/data';
import type { Client } from '@/client';
import SidebarTitle from './SidebarTitle.vue';
import PieceSearchBox from './buttons/PieceSearchBox.vue';
import LocaleSwitcher from './buttons/LocaleSwitcher.vue';
import LoginButton from './buttons/LoginButton.vue';

/**
 * A clone of Sidebar, that skips the dezrann-centric buttons and elements
 * The search box redirects directly to the collab score route
 */
@Component({
  components: {
    PieceSearchBox,
    SidebarTitle,
    LocaleSwitcher,
    LoginButton,
  },
})
export default class CollabScoreSidebar extends Vue {
  isMinified = true;

  @Prop({ default: [] })
  clients!: Client[];

  @Prop({ default: null })
  loginClient!: Client | null;

  isSynchronizable(piece: Piece): boolean {
    // If no tracks are available, don't display this piece
    if (piece.availableTracks <= 0) return false;
    // If no score are available, don't display this piece
    // Remove to display audio-only pieces
    if (piece.availableScores <= 0) return false;

    return true;
  }

  getCollabLink(piece: Piece): string {
    return (piece.isLocal ? '/local-collab/' : '/collab/') + piece.path;
  }
}
</script>
<style scoped lang="scss">

// Override vuetify navbar title hide
// Prevents titles from disappearing during mini transition

// v-deep and normal selectors, to affect this but also affect child components
::v-deep .v-navigation-drawer--mini-variant .v-list-item > :not(:first-child)
{
  position: inherit !important;
  height: initial;
  width: initial;
  overflow: initial;
  clip: initial;
  white-space: initial;
  display: flex;
}
::v-deep .v-navigation-drawer--mini-variant .v-list-item > :first-child {
  margin-right: 32px;
}
</style>
